---
title: RTCIceServer
slug: Web/API/RTCIceServer
tags:
  - Authentication
  - Configuration
  - Dictionary
  - Experimental
  - ICE
  - RTCIceServer
  - WebRTC
---
<p>{{DefaultAPISidebar("WebRTC")}}</p>

<p>The <code><strong>RTCIceServer</strong></code> dictionary defines how to connect to a single ICE server (such as a {{Glossary("STUN")}} or {{Glossary("TURN")}} server). Objects of this type are provided in the <a href="/en-US/docs/Web/API/RTCConfiguration">configuration</a> of an {{domxref("RTCPeerConnection")}}, in the {{domxref("RTCConfiguration.iceServers", "iceServers")}} array.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("RTCIceServer.credential", "credential")}} {{optional_inline}}</dt>
 <dd>The credential to use when logging into the server. This is only used if the <code>RTCIceServer</code> represents a TURN server.</dd>
 <dt>{{domxref("RTCIceServer.credentialType", "credentialType")}} {{optional_inline}}</dt>
 <dd>If the <code>RTCIceServer</code> represents a TURN server, this attribute specifies what kind of <code>credential</code> is to be used when connecting. This must be one of the values defined by the {{domxref("RTCIceCredentialType")}} enum. The default is <code>password</code>.</dd>
 <dt>{{domxref("RTCIceServer.urls", "urls")}}</dt>
 <dd>This <strong>required</strong> property is either a single {{domxref("DOMString")}} or an array of {{domxref("DOMString")}}s, each specifying a URL which can be used to connect to the server.</dd>
 <dt>{{domxref("RTCIceServer.username", "username")}} {{optional_inline}}</dt>
 <dd>If the <code>RTCIceServer</code> is a TURN server, then this is the username to use during the authentication process.</dd>
</dl>

<p>Avoid specifying an unnecessarily large number of URLs in the <code>urls</code> property; the startup time for your connection will go up substantially. Every server in the list will be contacted and tried out before one is selected to be used for negotiation.</p>

<div class="note">
<p>Older versions of the WebRTC specification included an <code>url</code> property instead of <code>urls</code>; this was changed in order to let you specify multiple addresses for each server in the list, as shown in the example below.</p>
</div>

<h2 id="Obsolete_properties">Obsolete properties</h2>

<p><em>The following properties have been removed from the specification and should not be used.</em></p>

<dl>
 <dt>{{domxref("RTCIceServer.url", "url")}} {{obsolete_inline}}</dt>
 <dd>This obsolete property is a string specifies a single ICE server's URL. <strong>Do not use this property; use {{domxref("RTCIceServer.urls", "urls")}} instead.</strong> Because many older books and examples still use this, we include it to help developers update their code or make sense of older examples.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The configuration below establishes two ICE servers. The first one, <code>stun:stun.services.mozilla.com</code>, requires authentication, so the username and password are provided. The second server has two URLs: <code>stun:stun.example.com</code> and <code>stun:stun-1.example.com</code>.</p>

<pre class="brush: js notranslate">var configuration = { iceServers: [{
                          urls: "stun:stun.services.mozilla.com",
                          username: "louis@mozilla.com",
                          credential: "webrtcdemo"
                      }, {
                          urls: [
                                  "stun:stun.example.com",
                                  "stun:stun-1.example.com"
                          ]
                      }]
};

var pc = new RTCPeerConnection(configuration);</pre>

<p>Once the configuration object has been created, it is passed into the {{domxref("RTCPeerConnection.RTCPeerConnection", "RTCPeerConnection()")}} constructor to use it as the configuration for the new peer connection.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCIceServer")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("RTCPeerConnection")}}</li>
 <li>{{domxref("RTCConfiguration")}}</li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Connectivity">WebRTC connectivity</a></li>
</ul>
